function varargout = HighlightConfiguration(varargin)
% HIGHLIGHTCONFIGURATION MATLAB code for HighlightConfiguration.fig
%      HIGHLIGHTCONFIGURATION, by itself, creates a new HIGHLIGHTCONFIGURATION or raises the existing
%      singleton*.
%
%      H = HIGHLIGHTCONFIGURATION returns the handle to a new HIGHLIGHTCONFIGURATION or the handle to
%      the existing singleton*.
%
%      HIGHLIGHTCONFIGURATION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in HIGHLIGHTCONFIGURATION.M with the given input arguments.
%
%      HIGHLIGHTCONFIGURATION('Property','Value',...) creates a new HIGHLIGHTCONFIGURATION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before HighlightConfiguration_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to HighlightConfiguration_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help HighlightConfiguration

% Last Modified by GUIDE v2.5 27-Jun-2017 16:05:36

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @HighlightConfiguration_OpeningFcn, ...
                   'gui_OutputFcn',  @HighlightConfiguration_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before HighlightConfiguration is made visible.
function HighlightConfiguration_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to HighlightConfiguration (see VARARGIN)

% Choose default command line output for HighlightConfiguration
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

global cellmatrix exportmat original_cellmatrix Alpha_value


original_cellmatrix = cell2mat(varargin(1));

  for m=1:size(exportmat,1)
        exportmat{m,14}=exportmat{m,14}/(2*pi);    % colimn 14: the preferred direction    
        if ~exportmat{m,15}                        % colimn 15: if is a real directional selective neuron 1=yes and keep; 0=no and delete   
            exportmat{m,14}=1;
        end
        exportmat{m,16}=exportmat{m,16};           % colimn 14: the normalized vector sum   
        if ~exportmat{m,15}
            exportmat{m,16}=1;
        end
        exportmat{m,18}=exportmat{m,18}/pi;        % colimn 18: the preferred orientation    
        if ~exportmat{m,19}                        % colimn 19: if is a real orientational selective neuron 1=yes and keep; 0=no and delete   
            exportmat{m,18}=1;
        end   
  end
cellmatrix = original_cellmatrix(1:varargin{3},:);

High_Lightcolumndata=get(handles.High_Light,'Data');
High_Lightcolumndata(:,1)={false};         
High_Lightcolumndata(:,[2,6,10])={'PD'};
High_Lightcolumndata(:,[3,11])={'>'};
High_Lightcolumndata(:,7)={'<='};
High_Lightcolumndata(:,[4,8,12])={0};
High_Lightcolumndata(:,5)={'DONE'};
High_Lightcolumndata(:,9)={'DONE'};
set(handles.High_Light,'Data',High_Lightcolumndata);
Alpha_value=0.5;
set(handles.Edit_Alpha,'String','0.5');
set(handles.radiobutton_All,'Value',1)                  % show all the cells by default
 
guidata(hObject, handles);
 
 



% UIWAIT makes HighlightConfiguration wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = HighlightConfiguration_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on key press with focus on High_Light and none of its controls.
function High_Light_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to High_Light (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in Show_Cells.
function Show_Cells_Callback(hObject, eventdata, handles)
% hObject    handle to Show_Cells (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global filtersettings exportmat cellmatrix region filternames showlegend h_cam original_cellmatrix Alpha_value

region=1;

show_choice=get(handles.radiobutton_All,'Value')*3+get(handles.radiobutton_Tectum,'Value')+2*get(handles.radiobutton_Pretectum,'Value');
filtersettings=get(handles.High_Light,'Data');
output=cellmatrix;

tempresult_left=zeros(size(exportmat,1),size(filtersettings,1));
tempresult_right=tempresult_left;
tempresult_middle=tempresult_left;

number_of_colors=sum(cell2mat(filtersettings(:,1)));
shown_index=double(cell2mat(filtersettings(:,end)));
if ~shown_index
    errordlg('please check at least one shown checker box','Selection Error');
end

finallogical=tempresult_left;
clear filternames
for k=1:size(filtersettings,1)
    
    factor_index=0;
    if strcmpi('PD',filtersettings(k,2))
         factor_index=2*pi;
    elseif strcmpi('Tuning width',filtersettings(k,2))
         factor_index=1;
    elseif strcmpi('PO',filtersettings(k,2))
         factor_index=pi;
    else
         disp('Please choose from PD PO and tuning width.')
    end
    
    if strcmpi(filtersettings(k,9),'&&') || strcmpi(filtersettings(k,9),'||')
        filternames{k,1}=[filtersettings{k,2} filtersettings{k,3}, num2str(factor_index*filtersettings{k,4}),...
            filtersettings{k,5}, filtersettings{k,6},filtersettings{k,7}, num2str(factor_index*filtersettings{k,8}),...
            filtersettings{k,9}, filtersettings{k,10},filtersettings{k,11}, num2str(factor_index*filtersettings{k,12})]; 
        
    else        
      if strcmpi(filtersettings(k,5),'&&') || strcmpi(filtersettings(k,5),'||')
        filternames{k,1}=[filtersettings{k,2} filtersettings{k,3}, num2str(factor_index*filtersettings{k,4}),...
            filtersettings{k,5}, filtersettings{k,6},filtersettings{k,7}, num2str(factor_index*filtersettings{k,8})];
      else
        filternames{k,1}=[filtersettings{k,2}, filtersettings{k,3}, num2str(factor_index*filtersettings{k,4})];
      end
      
    end
    
    exportmat_index=0;
    if strcmpi('PD',filtersettings(k,2))
         exportmat_index=14;
    elseif strcmpi('Tuning width',filtersettings(k,2))
         exportmat_index=16;
    elseif strcmpi('PO',filtersettings(k,2))
         exportmat_index=18;
    else
         disp('Please choose from PD PO and tuning width.')
    end
    
if  exportmat_index 
    if filtersettings{k,1}==1
        for m=1:size(exportmat,1)
            temp=exportmat{m,exportmat_index};                                        % left side filter
            if strcmpi(filtersettings(k,3),'>')
                tempresult_left(m,k)=temp.*(temp>filtersettings{k,4});
                templogical_left(m,k)=temp>filtersettings{k,4};
            elseif strcmpi(filtersettings(k,3),'<=')
                tempresult_left(m,k)=temp.*(temp<=filtersettings{k,4});
                templogical_left(m,k)=temp<=filtersettings{k,4};
            end
            
            if strcmpi(filtersettings(k,5),'&&') || strcmpi(filtersettings(k,5),'||') % middle filter
                temp=exportmat{m,exportmat_index};   
                if strcmpi(filtersettings(k,7),'>')
                    tempresult_middle(m,k)=temp.*(temp>filtersettings{k,8});
                    templogical_middle(m,k)=temp>filtersettings{k,8};
                elseif strcmpi(filtersettings(k,7),'<=')
                    tempresult_middle(m,k)=temp.*(temp<=filtersettings{k,8});
                    templogical_middle(m,k)=temp<=filtersettings{k,8};
                end
            end  
            
            if strcmpi(filtersettings(k,9),'&&') || strcmpi(filtersettings(k,9),'||') % right side filter
                temp=exportmat{m,exportmat_index};   
                if strcmpi(filtersettings(k,11),'>')
                    tempresult_right(m,k)=temp.*(temp>filtersettings{k,12});
                    templogical_right(m,k)=temp>filtersettings{k,12};
                elseif strcmpi(filtersettings(k,11),'<=')
                    tempresult_right(m,k)=temp.*(temp<=filtersettings{k,12});
                    templogical_right(m,k)=temp<=filtersettings{k,12};
                end
            end
% % % % %  three columns of filters  % % % % % %

            if strcmpi(filtersettings(k,5),'DONE')
                    finallogical(m,k)=templogical_left(m,k);         
            elseif strcmpi(filtersettings(k,5),'&&') 
                    if strcmpi(filtersettings(k,9),'&&')
                    
                          if (templogical_left(m,k)==0) || (templogical_middle(m,k)==0) || (templogical_right(m,k)==0)
                            finallogical(m,k)=0;
                          else
                            finallogical(m,k)=1;
                          end
                  
                   elseif strcmpi(filtersettings(k,9),'||')
                    
                          if (templogical_left(m,k)==0) || (templogical_middle(m,k)==0) 
                            finallogical(m,k)=0;
                          else
                             finallogical(m,k)=1;
                          end 
                          if (templogical_right(m,k)==1)
                               finallogical(m,k)=1;
                          end
                  
                   else 
                    
                          if (templogical_left(m,k)==0) || (templogical_middle(m,k)==0)
                            finallogical(m,k)=0;
                          else
                            finallogical(m,k)=1;
                          end
                   end
                
            elseif strcmpi(filtersettings(k,5),'||')
                
                   if strcmpi(filtersettings(k,9),'||')
                
                        if (templogical_left(m,k)==1) || (templogical_middle(m,k)==1) || (templogical_right(m,k)==1)
                          finallogical(m,k)=1;
                        else
                          finallogical(m,k)=0;
                        end
                   elseif strcmpi(filtersettings(k,9),'&&')  
                        if (templogical_right(m,k)==0)
                          finallogical(m,k)=0;
                        else
                           if (templogical_left(m,k)==1) || (templogical_middle(m,k)==1) 
                              finallogical(m,k)=1;
                           else
                              finallogical(m,k)=0;
                           end
                        end     
                  else
                        if (templogical_left(m,k)==1) || (templogical_middle(m,k)==1) 
                            finallogical(m,k)=1;
                        else
                            finallogical(m,k)=0;
                        end
                  end 
            end  
            
            
           switch exportmat_index
                  case 14   
                        if ~exportmat{m,15}
                             finallogical(m,k)=0;
                        end
                  case 16   
                        if ~exportmat{m,17}
                             finallogical(m,k)=0;
                        end
                  case 18   
                        if ~exportmat{m,19}
                             finallogical(m,k)=0;
                        end
           end 
            
        end
    else filternames{k,1}='not assigned';
    end
end
end


filternames{end+1,1}='multiple classes assigned';


for r=1:size(finallogical,1)
    output(r,6)=0;
    loc_positive=0;
    loc_positive=find(finallogical(r,1:end-1));
    if ismember(loc_positive,find(shown_index))
       output(r,6)=1;
    end
    if sum(finallogical(r,1:end-1),2)==0
        output(r,4)=1;
        output(r,5)=0.2;
    elseif sum(finallogical(r,1:end-1),2)==1
        indtrue=find(finallogical(r,:)==1);
        output(r,4)=indtrue+1;
        output(r,5)=abs(tempresult_left(r,indtrue));
    else
        output(r,4)=number_of_colors+2;
        output(r,5)=0.7;
    end
end

output(:,7)=cell2mat(exportmat(:,6));               % 2017/06/26   add the location of the cells to 7th column of the matrix
output(:,8)=cell2mat(exportmat(:,8));               % 2017/06/26   add the old or new recordings of the cells to 8th column the matrix
new_output=zeros(size(original_cellmatrix,1),8);
new_output(:,1:5)=original_cellmatrix;

new_output(1:size(output,1),:)=output;
cell_number=size(output,1);

h_cam=show3dposition_5_131005(output,get(handles.Label_Cell_Nummber,'Value'),region,showlegend,filternames,get(handles.Hide_Unclassified_Cells,'Value'),number_of_colors,Alpha_value,show_choice); % don't show boundary



% --- Executes when entered data in editable cell(s) in High_Light.
function High_Light_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to High_Light (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in Hide_Unclassified_Cells.
function Hide_Unclassified_Cells_Callback(hObject, eventdata, handles)
% hObject    handle to Hide_Unclassified_Cells (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Hide_Unclassified_Cells


% --- Executes on button press in Show_Boundary.
function Show_Boundary_Callback(hObject, eventdata, handles)
% hObject    handle to Show_Boundary (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Show_Boundary


% --- Executes on button press in Label_Cell_Nummber.
function Label_Cell_Nummber_Callback(hObject, eventdata, handles)
% hObject    handle to Label_Cell_Nummber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Label_Cell_Nummber


% --- Executes during object creation, after setting all properties.
function High_Light_CreateFcn(hObject, eventdata, handles)
% hObject    handle to High_Light (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called



function Edit_Alpha_Callback(hObject, eventdata, handles)
% hObject    handle to Edit_Alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Edit_Alpha as text
%        str2double(get(hObject,'String')) returns contents of Edit_Alpha as a double
global Alpha_value
Alpha_value=str2double(get(handles.Edit_Alpha,'String'));

% --- Executes during object creation, after setting all properties.
function Edit_Alpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Edit_Alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global file path h_cam

if ishandle(98)
  figure(98);
  set(gcf, 'Position', [10 10 1024 768])
  filename=[path file(1:end-14) datestr(now,'mmddyy') '_' datestr(now,'HHMMSS')];
  if get(handles.Show_Boundary,'Value')
      filename=[filename '_with_boundary'];
  end
  axis vis3d;
  xlim([-130,130]);
  ylim([-220,40]);
  zlim([-100,125]);
  view(270,90);
  camlight(h_cam,'headlight')
  saveas(98,[filename '_frontal'], 'png');
  saveas(98,[filename '_frontal'], 'fig');

  view(270,0);
  camlight(h_cam,'headlight')
  saveas(98,[filename '_sagittal'], 'png');
  saveas(98,[filename '_sagittal'], 'fig');
  view(0,0);
  camlight(h_cam,'headlight')
  saveas(98,[filename '_transversal_back'], 'png');
  saveas(98,[filename '_transversal_back'], 'fig');
  view(180,0);
  camlight(h_cam,'headlight')
  saveas(98,[filename '_transversal_front'], 'png');
  saveas(98,[filename '_transversal_front'], 'fig');
  msgbox('Operation Completed');
else
    errordlg('Please plot the cells first');
end



% --- Executes on button press in radiobutton_All.
function radiobutton_All_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_All (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_All
guidata(hObject, handles);
if get(hObject,'Value') 
    set(handles.radiobutton_Tectum,'Value',0)
    set(handles.radiobutton_Pretectum,'Value',0)
end

% --- Executes on button press in radiobutton_Tectum.
function radiobutton_Tectum_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_Tectum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_Tectum
guidata(hObject, handles);
if get(hObject,'Value') 
    set(handles.radiobutton_All,'Value',0)
    set(handles.radiobutton_Pretectum,'Value',0)
end

% --- Executes on button press in radiobutton_Pretectum.
function radiobutton_Pretectum_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_Pretectum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_Pretectum
guidata(hObject, handles);
if get(hObject,'Value') 
    set(handles.radiobutton_All,'Value',0)
    set(handles.radiobutton_Tectum,'Value',0)
end
