function [line_x_fit,line_y_fit,R_square]=fit_fourier3(line_x_ori,line_y_ori)

% fit data with 'fourier3'
% inputs: line_x_ori    x values to be fitted       standard x values 
%          line_y_ori   y values to be fitted
% outputs: line_x_fit   x values to be fitted       standard x values        
%          line_y_fit   y values to be fitted
%          R square


line_x_fit=1:512;
line_x_fit=line_x_fit';
ft = fittype( 'fourier3' );
opts = fitoptions( 'Method', 'NonlinearLeastSquares' );

[fitresult, gof] = fit(line_x_ori, line_y_ori, ft, opts );

line_y_fit=fitresult.a0+fitresult.a1*cos(line_x_fit*fitresult.w)+fitresult.b1*sin(line_x_fit*fitresult.w)+...
    fitresult.a2*cos(2*line_x_fit*fitresult.w)+fitresult.b2*sin(2*line_x_fit*fitresult.w)+fitresult.a3*cos(3*line_x_fit*fitresult.w)...
    +fitresult.b3*sin(3*line_x_fit*fitresult.w);
R_square=gof.rsquare;